##############################################################################
#
#  phpMyAdmin Version Detection 
#
#  Copyright: SecPod
#
#  Date Written: 2008/09/23
#
#  Revision: 1.1
#
#  Log: ssharath
#  Issue #0252
#  ------------------------------------------------------------------------
#  This program was written by SecPod and is licensed under the GNU GPL 
#  license. Please refer to the below link for details,
#  http://www.gnu.org/licenses/gpl.html
#  This header contains information regarding licensing terms under the GPL, 
#  and information regarding obtaining source code from the Author. 
#  Consequently, pursuant to section 3(c) of the GPL, you must accompany the 
#  information found in this header with any distribution you make of this 
#  Program.
#  ------------------------------------------------------------------------
##############################################################################

if(description)
{
 script_id(900129);
 script_copyright(english:"Copyright (C) 2008 SecPod");
 script_version("Revision: 1.1 ");
 script_category(ACT_GATHER_INFO);
 script_family(english:"General");
 script_name(english:"phpMyAdmin Version Detection");
 script_summary(english:"Set File Version of phpMyAdmin in KB");
 desc["english"] = "
 Overview : This script finds the phpMyAdmin installed version and 
 saves the version in KB.
 
 Risk factor : Informational";

 script_description(english:desc["english"]);
 script_dependencies("http_version.nasl");
 script_require_ports("Services/www", 80);
 exit(0);
}


 include("http_func.inc");
 include("http_keepalive.inc");

 port = get_http_port(default:80);
 if(!port){
        exit(0);
 }

 foreach dir (make_list("/phpmyadmin", cgi_dirs()))
 {
        sndReq = http_get(item:string(dir, "/index.php"), port:port);
        rcvRes = http_keepalive_send_recv(port:port, data:sndReq);
        if(rcvRes == NULL){
                exit(0);
        }

        if(egrep(pattern:"^HTTP/.* 200 OK", string:rcvRes))
        {
                phpmaVer = egrep(pattern:"phpMyAdmin [0-9.]+", string:rcvRes);
                phpmaVer = eregmatch(pattern:"[0-9.]+", string:phpmaVer);
                if(phpmaVer != NULL){
                         set_kb_item(name:"www/"+ port + "/phpMyAdmin",
                                      value:phpmaVer[0] + " under " + dir);
                }
        }
 }
