##############################################################################
#
#  NuMedia Soft DVD Burning SDK Activex Control Remote Code Execution Vulnerability
#
#  Copyright: SecPod
#
#  Date Written: 2008/11/03
#
#  Revision: 1.2
#
#  Log : ssharath
#  Issue #0394
#  ------------------------------------------------------------------------
#  This program was written by SecPod and is licensed under the GNU GPL 
#  license. Please refer to the below link for details,
#  http://www.gnu.org/licenses/gpl.html
#  This header contains information regarding licensing terms under the GPL, 
#  and information regarding obtaining source code from the Author. 
#  Consequently, pursuant to section 3(c) of the GPL, you must accompany the 
#  information found in this header with any distribution you make of this 
#  Program.
#  ------------------------------------------------------------------------
##############################################################################

if(description)
{
  script_id(900132);
  script_bugtraq_id(31374);
  script_cve_id("CVE-2008-4342");
  script_copyright(english:"Copyright (C) 2008 SecPod");
  script_version("Revision: 1.2 ");
  script_category(ACT_GATHER_INFO);
  script_family(english:"Misc.");
  script_name(english:"NuMedia Soft DVD Burning SDK Activex Control Remote Code Execution Vulnerability");
  script_summary(english:"Check for vulnerable version of CDBurnerXP");
  desc["english"] = "

  Overview : The host is installed CDBurnerXP, which is prone to ActiveX control
  based remote code execution vulnerability.

  Vulnerability Insight :
  The flaw is caused due to an error in validating/sanitizing the input data
  sent to NMSDVDX.dll file.

  Impact : Exploitation will cause Internet Explorer to restrict the webpage
  from running scripts and could overwrite files with arbitrary content.

  Impact Level : Application

  Affected Software/OS :
  - CDBurnerXP versions 4.2.1.976 and prior on all platform
  - Numedia NMS DVD Burning SDK ActiveX version 1.013C and prior
  - Mystik Media Blaze Media Pro version 8.02.0009 Special Edition and prior
 
  Fix : Set the kill-bit for the affected ActiveX control.
  No solution/patch is available as on 03rd November, 2008.

  References :
  http://cdburnerxp.se/en/home
  http://secunia.com/advisories/32455/
  http://secunia.com/advisories/31949/
  http://secunia.com/advisories/31936/
  http://www.milw0rm.com/exploits/6491

  CVSS Score :
    CVSS Base Score     : 5.1 (AV:N/AC:H/Au:NR/C:P/I:P/A:P)
    CVSS Temporal Score : 4.6
  Risk factor : Medium";

  script_description(english:desc["english"]);
  script_dependencies("secpod_reg_enum.nasl");
  script_require_keys("SMB/WindowsVersion");
  exit(0);
}

include("secpod_smb_func.inc");

if(!get_kb_item("SMB/WindowsVersion")){
  exit(0);
}

clsid = "{C2FBBB5F-6FF7-4F6B-93A3-7EDB509AA938}";
regKey = "SOFTWARE\Classes\CLSID\"+ clsid;
if(registry_key_exists(key:regKey))
{
  # Check for Kill-Bit set for ActiveX control
  activeKey = "SOFTWARE\Microsoft\Internet Explorer\"+
              "ActiveX Compatibility\" + clsid;
  killBit = registry_get_dword(key:activeKey, item:"Compatibility Flags");
  if(killBit && (int(killBit) == 1024)){
    exit(0);
  }
  security_warning(0);
}
